<?php
    include "../conexion/conexion.php";
    include '../validacion.php';
    date_default_timezone_set("America/Lima");

    $idagenda = $_GET["agenda"];

    $celular = $_POST["txtcelular"];
    $postulante = $_POST["txtpostulante"];
    $tipodocumento = $_POST["cbotipodocumento"];
    $numerodocumentoe = $_POST["txtnumerodocumento"];
    $numerodocumento = trim($numerodocumentoe);
    $edad = $_POST["cboedad"];
    $distrito = $_POST["cbodistrito"];
    $fuente = $_POST["cbofuente"];
    $fechaagenda = $_POST["txtfechaagenda"];
    $turno = $_POST["cboturno"];
    $observaciones = $_POST["txtobservaciones"];
    
    if(isset($_POST['cboidusuario'])){
        $idusuario = $_POST['cboidusuario'];
    }
    $sede = $_POST['cbosede'];
    $fecharegistros = $_POST['txtfecharegistro'];
    $validador1 = date("Y-m-d",strtotime("$fecharegistros + 1 days"));
    $validador2 = date("Y-m-d",strtotime("$fecharegistros + 2 days"));




    date_default_timezone_set('America/Lima');
    $dia = date("d");
    $mes = date("m");
    $año = date("Y");

    $fechas = "$año-$mes-$dia";
    $fecha = strtotime($fechas);
    $diax = date("w",$fecha);
    $semanax = date("W",$fecha);
    
    if($mes == 1){
      if($dia == 31 && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 30  && $diax == 6){
        $dia = 1;
        $mes = 2;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{   
        $dia = $dia + 1;
      }
    }
    else if($mes == 2){
      if($dia == 29){
        if($diax == 6){
          $mes = $mes + 1;
          $dia = 2;
        } 
        else{
          $mes = $mes + 1;
          $dia = 1;
        }
      }
      else if($dia == 28 && (($año % 4 == 0 && $año % 100 != 0) || $año % 400 == 0)){
        if($diax == 6){
          $dia = 1;
          $mes = $mes + 1;
        }
        else{
          $dia = $dia + 1;
        }  
      }
      else if($dia == 28){
        if($diax == 6){
          $dia = 2;
          $mes = $mes + 1;
        }
        else{
          $mes = $mes + 1;
          $dia = 1;
        }  
      }
      else if($dia == 27 && ($año % 4 == 0 && $año % 100 != 0) && $año % 400 == 0){
        if($diax == 6 ){
          $dia = $dia + 2;
        }
        else{
          $mes = $mes + 1;
          $dia = 1;
        }  
      }
      else if($diax == 6 && $dia != 27 || $dia !=29){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes == 3){
      if($dia == 31  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 30  && $diax == 6){
        $dia = 1;
        $mes = 4;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes ==4){
      if($dia == 30  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 29  && $diax == 6){
        $dia = 1;
        $mes = 5;
      }
      else if($diax == 6 && $dia != 29){
        $dia = $dia + 2;
      }
      else{
          $dia = $dia + 1;
      }
    }
    else if($mes == 5){
      if($dia == 31  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 30  && $diax == 6){
        $dia = 1;
        $mes = 6;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{
          $dia = $dia + 1;
      }
    }
    else if($mes == 6){
      if($dia == 30  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 29  && $diax == 6){
        $dia = 1;
        $mes = 7;
      }
      else if($diax == 6 && $dia != 29){
        $dia = $dia + 2;
      }
      else{
          $dia = $dia + 1;
      }
    }
    else if($mes == 7){
      if($dia == 31  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 30  && $diax == 6){
        $dia = 1;
        $mes = 8;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes == 8){
      if($dia == 31  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 30 && $diax == 6){
        $dia = 1;
        $mes = 9;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes == 9){
      if($dia == 30  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      if($dia == 30  && $diax != 6){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 29  && $diax == 6){
        $dia = 1;
        $mes = 10;
      }
      else if($diax == 6 && $dia != 29){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes == 10){
      if($dia == 31  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 30  && $diax == 6){
        $dia = 1;
        $mes = 11;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes == 11){
      if($dia == 30  && $diax == 0){
        $mes = $mes + 1;
        $dia = 1;
      }
      else if($dia == 29  && $diax == 6){
        $dia = 1;
        $mes = 12;
      }
      else if($diax == 6 && $dia != 29){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    else if($mes == 12){
      if($dia == 31  && $diax == 0){
        $año = $año + 1;
        $dia = 1;
      }
      else if($dia == 30 && $diax == 6){
        $dia = 1;
        $mes = 1;
        $año = $año + 1;
      }
      else if($diax == 6 && $dia != 30){
        $dia = $dia + 2;
      }
      else{
        $dia = $dia + 1;
      }
    }
    
    if($dia > 0 && $dia < 10){
      $dia = "0".$dia;
    }
    if($mes > 0 && $mes < 10){
      if(strlen($mes) == 1){
      $mes = "0".$mes;
      }
    }
    
    $next = $año."-".$mes."-".$dia;


    // ------------------------





    $fechas = date("Y-m-d");
    $fechass = strtotime($fechas);
    $diax = date("w",$fechass);


    if(isset($_POST["cboasistencia"])){$asistencia = $_POST["cboasistencia"];}
    else{$asistencia = "NO";}
    
    if(isset($_POST["cboagenda"])){
        
        if($diax == 6){
            if($validador2 == $next){
                $agenda = "AGENDADO";
            }
            else{
                $agenda = "REPROGRAMADO";
            }
        }
        else{
            
            if($validador2 == $fechaagenda){
                $agenda = $_POST["cboagenda"];
            }
            else if($validador1 == $next){
                $agenda = "AGENDADO";
            }
            else{
                $agenda = "REPROGRAMADO";
            }
        }
    }
    else{$agenda = "";}
    
    
    

    if(isset($_POST["cboestado"])){$estado = $_POST["cboestado"];}
    else{$estado = "";}
    
    if(isset($_POST["cboestadofinal"])){$estadofinal = $_POST["cboestadofinal"];}
    else{$estadofinal = "";}
    
    $fechaagenda = $_POST["txtfechaagenda"];
    if($agenda == "REPROGRAMADO"){
        $fechareprogramacion = $_POST['txtfechaagenda']; 
    }
    else{
        $fechareprogramacion = ""; 
    }
    
    // $fecharegistro = date("Y-m-d");
    // $horaregistro = date("H:i:s");
    
    // $celular='$celular',
    
    
    try{
        
        if (strlen($numerodocumento) >= 0 || $numerodocumento == "."){
                
                $sql = "select count(*) from agenda where numerodocumento='$numerodocumento'";
                $ndocumentos = current($pdo->query($sql)->fetch());
                
                if(strlen($numerodocumento) >= 0 || $numerodocumento == "."){
        
                    if(isset($_POST['cboidusuario'])){
                        $sql="UPDATE agenda SET 
                        postulante='$postulante',
                        celular='$celular',
                        tipodocumento='$tipodocumento',
                        numerodocumento='$numerodocumento',
                        edad='$edad',
                        celular = '$celular',
                        distrito='$distrito',
                        fuente='$fuente',
                        fechaagenda='$fechaagenda',
                        turno='$turno',
                        sede='$sede',
                        observaciones='$observaciones',
                        agenda='$agenda',
                        estado='$estado',
                        estadofinal='$estadofinal',
                        fechareprogramacion='$fechareprogramacion',
                        idusuario='$idusuario',
                        asistencia='$asistencia'
                        WHERE idagenda=$idagenda";
                    }
                    else{
                        $sql="UPDATE agenda SET 
                        postulante='$postulante',
                        celular='$celular',
                        tipodocumento='$tipodocumento',
                        numerodocumento='$numerodocumento',
                        edad='$edad',
                        distrito='$distrito',
                        fuente='$fuente',
                        fechaagenda='$fechaagenda',
                        turno='$turno',
                        sede='$sede',
                        observaciones='$observaciones',
                        agenda='$agenda',
                        estado='$estado',
                        estadofinal='$estadofinal',
                        fechareprogramacion='$fechareprogramacion',
                        asistencia='$asistencia'
                        WHERE idagenda=$idagenda";
                    }
                }
                else{
                    echo '<script type="text/javascript">alert("Número de documento inválido");window.location.href="../login/inicio.php";</script>';
                }
        }
        else{
            echo '<script type="text/javascript">alert("Número de documento ya está registrado");window.location.href="../login/inicio.php";</script>';
        }
        
        
        $consulta = $pdo->prepare($sql);

        if($consulta->execute()){



            // AÑADIENDO EL REGISTRO LOG PARA AGENDA
            //----------------------------------------------------------------------------
            // IDTABLALOG = 2  ES AGENDA
            $sql = "SELECT * FROM tablalog WHERE idtablalog = 2";
            $consulta = $pdo->prepare($sql);
            $consulta->execute();
            $tablalog = $consulta->fetchAll(PDO::FETCH_ASSOC);

                foreach ($tablalog as $gotablalog) {
                    $idtablalog = $gotablalog['idtablalog'];
                    $nombretablalog = $gotablalog['nombretablalog'];
                }
            //----------------------------------------------------------------------------
            $sql = "SELECT * FROM agenda WHERE idagenda = '$idagenda'";
            $consulta = $pdo->prepare($sql);
            $consulta->execute();
            $tablaagenda = $consulta->fetchAll(PDO::FETCH_ASSOC);
    
                foreach ($tablaagenda as $gotablaagenda) {
                    $postulante = $gotablaagenda['postulante'];
                    $celular = $gotablaagenda['celular'];
                }

            //----------------------------------------------------------------------------
            $accion = $nombreusuario_sesion." HA MODIFICADO LA AGENDA DE ".$postulante." CON NÚMERO DE CELULAR: ".$celular;
            $crud = "ACTUALIZAR";
            //----------------------------------------------------------------------------
            $sql="INSERT INTO detalletablalog VALUES (null,?,?,?,?,?);";
            $sentencia = $pdo->prepare($sql);   
            $sentencia->bindParam(1,$accion);
            $sentencia->bindParam(2,$ahora);
            $sentencia->bindParam(3,$crud);
            $sentencia->bindParam(4,$idagenda);
            $sentencia->bindParam(5,$idtablalog);                
            $sentencia->execute();
            //----------------------------------------------------------------------------

            echo '<script type="text/javascript">alert("Actualzado correctamente!");window.location.href="../login/inicio.php";</script>';
        }
        else{
            echo '<script type="text/javascript">alert("Error al actualizar!");window.location.href="../login/inicio.php";</script>';
        }

    }

    catch(PDOException $e){
        echo $e->getMessage();
    }
?>